#!/bin/sh
# $Id: prebind.sh,v 5.6 1998/07/06 03:57:54 pb Exp $

LOCAL=Local
if test -f /usr/bin/uname
then
  if test `/usr/bin/uname` = "Rhapsody"
  then
    LOCAL=Local/
  fi
fi

ROOT=""
BINDIR="$ROOT/${LOCAL}Developer/Executables"
BINARIES="objpy objtclsh objperl python tclsh perl"
FDIR="$ROOT/${LOCAL}Library/Frameworks"
FRAMEWORKS="Python Tcl8 Perl ObjCore ObjAppKit ObjPy ObjTcl ObjPerl ObjBrowser ObjWebScript WOEverything"

echo "============================================================="
echo "Prebinding Objective-Everything stuff."
echo "Ignore objcunique (sel conflict) and __sel_backref warnings"
echo "============================================================="

for f in $FRAMEWORKS
do
  if test -d $FDIR/$f.framework
  then
    d=$FDIR/$f.framework/Versions/Current/
    x=$d/$f
    chmod u+w $d $x
    echo "PREBINDING $x"
    redo_prebinding $x
    chmod u-w $x $d
    echo "-------------------------------------------------------------"
  fi
done

for f in $BINARIES
do
  x=$BINDIR/$f
  if test -f $x
  then
    chmod u+w $x
    echo "PREBINDING $x"
    redo_prebinding $x
    chmod u-w $x
    echo "-------------------------------------------------------------"
  fi
done

if test ! -d ~/.AppInfo; then mkdir ~/.AppInfo; fi
if test ! -d ~/.AppInfo/Objective; then mkdir ~/.AppInfo/Objective; fi

# EOF
