// $Id: ObjAppKitDefines.h,v 5.3 1998/07/02 05:25:01 pb Exp $
/* Copyright (c) 1994-1998 TipTop Software, Inc.
   All Rights Reserved

   Author: Pedja Bogdanovich
*/

#ifndef _ObjAppKit_Defines_h
#define _ObjAppKit_Defines_h 1

//////////
// MACH //
//////////
#if defined __MACH__

#ifdef __cplusplus
#  define OBJAPPKIT_EXTERN		extern
#  define PRIVATE_EXTERN		__private_extern__
#else
#  define OBJAPPKIT_EXTERN		extern
#  define PRIVATE_EXTERN		__private_extern__
#endif

#define OBJAPPKIT_EXTERN_IMP	PUBLIC_EXTERN
#define PRIVATE_EXTERN_IMP	PRIVATE_EXTERN


/////////////
// Windows //
/////////////
#elif defined WIN32

#ifdef __cplusplus
#  ifndef BUILDING_OBJAPPKIT
#    define OBJAPPKIT_EXTERN		__declspec(dllexport) extern "C"
#  else
#    define OBJAPPKIT_EXTERN		__declspec(dllimport) extern "C"
#  endif
#  define OBJAPPKIT_PRIVATE_EXTERN		extern "C"
#else
#  ifndef BUILDING_OBJAPPKIT
#    define OBJAPPKIT_EXTERN		__declspec(dllexport) extern
#  else
#    define OBJAPPKIT_EXTERN		__declspec(dllimport) extern
#  endif
#    define OBJAPPKIT_PRIVATE_EXTERN		extern
#endif

#define OBJAPPKIT_EXTERN_IMP	PUBLIC_EXTERN
#define OBJAPPKIT_PRIVATE_EXTERN_IMP	PRIVATE_EXTERN


/////////////////////////////////
// Solaris and SolarisOpenStep //
/////////////////////////////////
#elif defined(__svr4__) || defined(sun)

#ifdef __cplusplus
#  define OBJAPPKIT_EXTERN		extern "C"
#  define OBJAPPKIT_PRIVATE_EXTERN		extern "C"
#else
#  define OBJAPPKIT_EXTERN		extern
#  define OBJAPPKIT_PRIVATE_EXTERN		extern
#endif

#define OBJAPPKIT_EXTERN_IMP	OBJAPPKIT_EXTERN
#define OBJAPPKIT_PRIVATE_EXTERN_IMP	PRIVATE_EXTERN

///////////
// HP UX //
///////////
#elif defined(hpux)

#ifdef __cplusplus
#  define OBJAPPKIT_EXTERN		extern "C"
#  define OBJAPPKIT_PRIVATE_EXTERN		extern "C"
#else
#  define OBJAPPKIT_EXTERN		extern
#  define OBJAPPKIT_PRIVATE_EXTERN		extern
#endif

#define OBJAPPKIT_EXTERN_IMP	OBJAPPKIT_EXTERN
#define OBJAPPKIT_PRIVATE_EXTERN_IMP	PRIVATE_EXTERN

/////////////////////
// SolarisOpenStep //
/////////////////////
#elif defined(SolarisOpenStep)

#ifdef __cplusplus
#  define OBJAPPKIT_EXTERN		extern "C"
#  define OBJAPPKIT_PRIVATE_EXTERN		extern "C"
#else
#  define OBJAPPKIT_EXTERN		extern
#  define OBJAPPKIT_PRIVATE_EXTERN		extern
#endif

#define OBJAPPKIT_EXTERN_IMP	OBJAPPKIT_EXTERN
#define OBJAPPKIT_PRIVATE_EXTERN_IMP	PRIVATE_EXTERN

#else

#error Unknown platform.

#endif

#endif
// EOF
