// $Id: TTObjectWell.h,v 5.3 1998/07/02 05:25:02 pb Exp $
/* Copyright (c) 1994-1998 TipTop Software, Inc.
   All Rights Reserved

   Author: Pedja Bogdanovich
*/

#import <AppKit/AppKit.h>

OBJAPPKIT_EXTERN NSString *TTObjectPboardType;

#define TTOBJECTWELL_BACKCOMPATIBILITY 1

@interface TTObjectWell : NSButton
{
@private
#if TTOBJECTWELL_BACKCOMPATIBILITY
  TTExecutor *_setupCode;
  id _auxObject;
#endif
  BOOL _dragSource;
  BOOL _dragDestination;
  id _dragObj;
  id _dropObj;
  BOOL _isLocal;
}

+ (NSString *)connectionName;

- (BOOL)dragSource;
- (void)setDragSource:(BOOL)f;
- (BOOL)dragDestination;
- (void)setDragDestination:(BOOL)f;

#if TTOBJECTWELL_BACKCOMPATIBILITY
- (NSString *)setupCode;
- (void)setSetupCode:(NSString*)s;
#endif

- (void)setDragObject:(id)o;
- (id)dragObject;
- (void)setDroppedObject:(id)o;
- (id)droppedObject;
- (BOOL)isLocal;

- (void)performDrop:sender;

#if TTOBJECTWELL_BACKCOMPATIBILITY
- (void)setAuxObject:o;
- (id)auxObject;
#endif

-(BOOL)writeDragDataForEvent:(NSEvent *)ev pboard:(NSPasteboard*)pboard;
@end

OBJAPPKIT_EXTERN id
TTObjectWell_GetDroppedObject(id client, const char *ospec, BOOL isLocal);

// EOF
