// $Id: TTWInteractor.h,v 5.3 1998/01/14 21:58:02 pb Exp $
/* Copyright (c) 1994-1998 TipTop Software, Inc.
   All Rights Reserved

   Author: Pedja Bogdanovich
*/
#import <AppKit/AppKit.h>
#import <ObjCore/TTInteractor.h>

@class TTCommandText;

#define IBOutlet

@interface TTWInteractor : TTInteractor
{
  IBOutlet NSWindow *_window;
  IBOutlet TTCommandText *_commandText;
  NSDictionary *_defaultAttr;
  NSDictionary *_errorAttr;
  NSDictionary *_resultAttr;
  unsigned _wflags;
  void *_wreserved;
}

- (void)setReleasedWhenClosed:(BOOL)f;
- (BOOL)isReleasedWhenClosed;

// IB actions:
- (void)run:(id)sender;
- (void)stop:(id)sender;

- (void)clearOutput:sender;
- (void)killCurrentCommand:sender;
- (void)flushHistory:sender;
- (void)saveHistory:sender;
- (void)copyHistory:sender;

- (NSArray*)history;
- (void)setHistory:(NSArray*)history;

- (void)printOut:(NSString*)text;
- (NSString*)readLineWithPrompt:(NSString*)prompt0
                            and:(NSString*)prompt2
                    defaultText:(NSString*)text;
@end

// EOF
