// $Id: TTOBCellProtocol.h,v 5.1 1998/01/14 21:55:48 pb Exp $
/* Copyright (c) 1994-1998 TipTop Software, Inc.
   All Rights Reserved

   Author: Pedja Bogdanovich
*/

#import <Foundation/Foundation.h>
@class TTObjBrowser;
@class NSEvent;
@class TTOBCCategory;

@protocol TTOBCellProtocol
-(NSString*)getCellName;
-(NSImage*)getCellImage;
-(id)infoForInspector;

-(BOOL)isCellValid;

-(BOOL)canBeRootCell;
-(id)copyNewRoot;

-(BOOL)loadCellAtRow:(int)r inColumn:(int)col;

// Populate l with (TTOBCCategory*) and return the name of the default category
-(NSString*)populateArrayWithSubcellCategories:(NSMutableArray*)l;

// Populate l with objects conforming to <TTOBCellProtocol>.
-(void)populateArray:(NSMutableArray*)l
       withSubcellsForCategory:(TTOBCCategory*)cat;

// Populate l with inspector class names (NSString*), and return the default
// class name.
-(NSString*)populateArray:(NSMutableArray*)l
            withInspectorClassNamesForCategory:(TTOBCCategory*)cat;

-(void)cellSelected;
-(void)cellDeselected;

-(void)setBrowser:(TTObjBrowser*)b;
-(TTObjBrowser*)browser;

-(void)setObject:(id)o;
-(id)object;

-(NSString*)dragDataForEvent:(NSEvent *)ev;
@end
// EOF
