/* $Id: TTObjBrowser.h,v 5.7 1998/07/02 05:24:22 pb Exp $ */
/* Copyright (c) 1994-1998 TipTop Software, Inc.
   All Rights Reserved

   Author: Pedja Bogdanovich
*/
#import <AppKit/AppKit.h>

@class TTOBCCategory;
@class TTOBPath;
@class TTOBCell;
@class TTPopupBrowser;

@interface TTObjBrowser : TTObject
{
@private
  TTPopupBrowser *_browser;
  TTOBCell *_rootCell;
  id _rootObject;
  id _inspectDriver;
  NSButton *_newBrowserButton;
  NSButton *_inspectorButton;
  NSMutableArray *_titleList;
  NSMutableArray *_catListList;
  NSMutableArray *_filterList;
  NSMutableArray *_controlCache;
  NSString *_defaultCategory;
  int _minRevCol, _selCol;
  unsigned _flags;
}

+ (id)browseFromObject:(id)obj path:(TTOBPath*)path;
+ (id)browseFromObject:(id)obj;

- (id)initForObject:(id)obj;
- (void)run;

- (TTOBCell*)selectedCell;
- (TTOBCCategory*)selectedCategory;
- (TTOBCell*)parentOfColumn:(int)col;
- (TTOBCell*)selectedCellInColumn:(int)col;
- (TTOBCCategory*)categoryInColumn:(int)col;
- (NSString*)filterInColumn:(int)col;
- (int)columnOfCell:(TTOBCell*)c;

// Actions:
- (void)showInspector:(id)sender;
- (void)showInteractor:(id)sender;
- (TTObjBrowser*)newBrowserForSelectedCell:(id)sender;
- (void)fullReload:(id)sender;
- (void)moveBack:(id)sender;

// Path operations:
- (TTOBPath*)pathFromColumn:(int)col;
- (BOOL)setPath:(TTOBPath*)path fromColumn:(int)col;
- (void)setCategoryName:(NSString *)cat inColumn:(int)col;
- (void)setFilter:(NSString*)ftext inColumn:(int)col;

- (void)loadColumnZero;
- (void)setLastColumn:(int)col;
- (void)reloadFromColumn:(int)col;

- (void)setReleasedWhenClosed:(BOOL)f;
- (BOOL)isReleasedWhenClosed;
@end

@interface TTObjBrowser(MorePublicStuff)
+ (NSImage*)getImageNamed:(NSString *)n;
- (TTOBCell*)newCellForObject:o;
+ (void)findInHeaderViewer:(NSString *)whatever;
@end

OB_EXTERN id TTOB_GetCellForObjBrowser(id o, TTObjBrowser *browser);

OB_EXTERN NSString *TTOBBrowserAddedNotification;
OB_EXTERN NSString *TTOBBrowserRemovedNotification;

// EOF
