# $Id: MyTreeNode+OBStuff.tcl,v 5.0 1997/12/07 23:18:49 pb Exp $

extend MyTreeNode {
# Associate name with MyTreeNode instances
method -(NSString*)obGetName { return [$self nodeName] }

# Associate image with MyTreNode class object and instances
method +(NSImage*)obGetImage {
  return [TTObjBrowser getImageNamed: [@ "MyTreeNode"]]
}

# Cell category hook
method -(NSString*)obPopulateArrayWithSubcellCategories:(NSMutableArray*)l {
  # Place MyLRCategory as the first element of the list
  $l insertObject: [MyLRCategory object] \
      atIndex: 0
  return [nil]
}

# Inspector hook
method -(NSString*)obPopulateArray:(NSMutableArray*)l \
                   withInspectorClassNamesForCategory:(TTOBCCategory*)t {
  super obPopulateArray: $l withInspectorClassNamesForCategory: $t
  $l insertObject: [@ MyTreeNodeInspector] atIndex: 0
  return [nil]
}
}


################################################################
# Cell category implementation
class MyLRCategory TTOBCCategory {
} {
# This is what's displayed in the category popup button.
method -(NSString*)stringValue { return [@ "L&R objects"] }

# Create subcells and add them into list l.
# This method is invoked by TTOBCell's -getSubcells:forCategory:
method -(void)populateArray:(NSMutableArray*)l \
	      withSubcellsForCell:(TTOBCell*)c {
  set o [$c object]
  set b [$c browser]
  
  set nl [$o left]
  set x [$b newCellForObject: $nl]
  if [tt $nl] { $x setStringValue: "left: [$nl nodeName]" } \
  else { $x setStringValue: "left: ---" }
  $l addObject: $x

  set nr [$o right]
  set x [$b newCellForObject: $nr]
  if [tt $nr] { $x setStringValue: "right: [$nr nodeName]" } \
  else { $x setStringValue: "right: ---" }
  $l addObject: $x

  # Add a label cell:
  set x [TTOBCLabel object]
  $x setStringValue: [@ "my label"]
  $l addObject: $x
}
}

# Inspector
class MyTreeNodeInspector TTOBInspector {
  id nameField;
  id leftNameField;
  id rightNameField;
} {
method +(NSString*)inspectorName { return "L&R" }
method -(BOOL)wantsButtons { return no }

# Load the nib file MyTreeNodeInspector.nib.
method -init {
  return [$self initAndLoadNib]
}

method -(void)revert: sender {
  set o [$self object]
  $nameField setStringValue: [$o nodeName]

  if ![tt [$o left]] { set lname "---" } \
  elseif [tt [[$o left] respondsToSelector: nodeName]] {
    set lname [[$o left] nodeName]
  } else { set lname "???" }
  $leftNameField setStringValue: $lname

  if ![tt [$o right]] { set rname "---" } \
  elseif [tt [[$o right] respondsToSelector: nodeName]] {
    set rname [[$o right] nodeName]
  } else { set rname "???" }
  $rightNameField setStringValue: $rname

  super revert: $sender
}

method -(void)ok: sender {
  # ....
  super ok: $sender
}  
}

#EOF
