// $Id: List.h,v 5.2 1998/05/25 21:32:28 pb Exp $
/* Copyright (c) 1994-1998 TipTop Software, Inc.
   All Rights Reserved

   Author: Pedja Bogdanovich
*/

#ifndef _compat_List_h
#define _compat_List_h

#include <objc/Object.h>

@interface List:Object
{
@public
  id *dataPtr;
  unsigned numElements;
  unsigned maxElements;
}

-init;
-initCount:(unsigned)c;
-free;
-freeObjects;
-empty;

-(BOOL)isEqual:l;
  
-(unsigned)capacity;
-setAvailableCapacity:(unsigned)cap;
-(unsigned)count;

-objectAt:(unsigned)i;
-lastObject;
-(unsigned)indexOf:obj;

-addObject:obj;
-insertObject:obj at:(unsigned)i;
-addObjectIfAbsent:obj;
-appendList:(List *)l;

-removeObjectAt:(unsigned)i;
-removeLastObject;
-removeObject:obj;

-replaceObject:obj with:nobj;
-replaceObjectAt:(unsigned)i with:obj;

-makeObjectsPerform:(SEL)aSel;
-makeObjectsPerform:(SEL)aSel with:anObject;

+newCount:(unsigned)numSlots;
@end

#define NX_NOT_IN_LIST	0xffffffff

#endif // _compat_List_h

// EOF
