/* $Id: ObjCoreDefines.h,v 5.2 1998/07/02 05:25:08 pb Exp $ */
/* Copyright (c) 1994-1998 TipTop Software, Inc.
   All Rights Reserved

   Author: Pedja Bogdanovich
*/

#ifndef _ObjCore_Defines_h
#define _ObjCore_Defines_h 1

//////////
// MACH //
//////////
#if defined __MACH__

#ifdef __cplusplus
#  define OBJCORE_EXTERN		extern
#  define PRIVATE_EXTERN		__private_extern__
#else
#  define OBJCORE_EXTERN		extern
#  define PRIVATE_EXTERN		__private_extern__
#endif

#define OBJCORE_EXTERN_IMP	PUBLIC_EXTERN
#define PRIVATE_EXTERN_IMP	PRIVATE_EXTERN


/////////////
// Windows //
/////////////
#elif defined WIN32

#ifdef __cplusplus
#  ifndef BUILDING_OBJCORE
#    define OBJCORE_EXTERN		__declspec(dllexport) extern "C"
#  else
#    define OBJCORE_EXTERN		__declspec(dllimport) extern "C"
#  endif
#  define OBJCORE_PRIVATE_EXTERN		extern "C"
#else
#  ifndef BUILDING_OBJCORE
#    define OBJCORE_EXTERN		__declspec(dllexport) extern
#  else
#    define OBJCORE_EXTERN		__declspec(dllimport) extern
#  endif
#    define OBJCORE_PRIVATE_EXTERN		extern
#endif

#define OBJCORE_EXTERN_IMP	PUBLIC_EXTERN
#define OBJCORE_PRIVATE_EXTERN_IMP	PRIVATE_EXTERN


/////////////////////////////////
// Solaris and SolarisOpenStep //
/////////////////////////////////
#elif defined(__svr4__) || defined(sun)

#ifdef __cplusplus
#  define OBJCORE_EXTERN		extern "C"
#  define OBJCORE_PRIVATE_EXTERN		extern "C"
#else
#  define OBJCORE_EXTERN		extern
#  define OBJCORE_PRIVATE_EXTERN		extern
#endif

#define OBJCORE_EXTERN_IMP	OBJCORE_EXTERN
#define OBJCORE_PRIVATE_EXTERN_IMP	PRIVATE_EXTERN

///////////
// HP UX //
///////////
#elif defined(hpux)

#ifdef __cplusplus
#  define OBJCORE_EXTERN		extern "C"
#  define OBJCORE_PRIVATE_EXTERN		extern "C"
#else
#  define OBJCORE_EXTERN		extern
#  define OBJCORE_PRIVATE_EXTERN		extern
#endif

#define OBJCORE_EXTERN_IMP	OBJCORE_EXTERN
#define OBJCORE_PRIVATE_EXTERN_IMP	PRIVATE_EXTERN

/////////////////////
// SolarisOpenStep //
/////////////////////
#elif defined(SolarisOpenStep)

#ifdef __cplusplus
#  define OBJCORE_EXTERN		extern "C"
#  define OBJCORE_PRIVATE_EXTERN		extern "C"
#else
#  define OBJCORE_EXTERN		extern
#  define OBJCORE_PRIVATE_EXTERN		extern
#endif

#define OBJCORE_EXTERN_IMP	OBJCORE_EXTERN
#define OBJCORE_PRIVATE_EXTERN_IMP	PRIVATE_EXTERN

#else

#error Unknown platform.

#endif

#endif
/* EOF */
