// $Id: TTCDatum.h,v 1.4 1998/07/05 23:12:42 pb Exp $
/* Copyright (c) 1994-1998 TipTop Software, Inc.
   All Rights Reserved

   Author: Pedja Bogdanovich
*/

@interface TTCDatum:TTObject
{
@private
  char *_name;
  void *_info;
  int _count;
  unsigned _flags;
  int _checkno;
}

- (id)initWithName:(NSString*)name;
- (id)initWithEncoding:(const char *)t
             atAddress:(void *)v
                 count:(int)count;
- (id)initWithEncoding:(const char *)encoding
              atSymbol:(const char *)addr;
- (id)initWithCDatum:(TTCDatum*)datum;

+ cdatumWithName:(NSString*)name;
+ cdatumWithEncoding:(const char *)enc
           atAddress:(void *)addr;
+ cdatumWithCDatum:(TTCDatum*)datum;

+ cdatumForObject:(id)obj;
+ cdatumForString:(NSString*)string;

- copyWithZone:(NSZone *)z;

- (void*)address;
- (const char *)encoding;
- (unsigned)count;

- (int)sizeOf;
- (unsigned long)addrOf;

- (TTCType*)ctype;
- (NSString*)typeString;
- (NSString*)objcRepresentation;
- (TTCDatum*)cdatumByCastingToCType:(TTCType*)ctype;

- (id)callWithCount:(int)count arguments:(id*)args;
- (id)fetch;
- (id)valueForKey:(NSString*)key;
- (void)store:(id)val;
- (void)takeValue:(id)val forKey:(NSString*)key;

- (void)defineDatumName:(NSString*)nm;

- (void)datumRealloc:(int)count;
- (void)datumOffset:(int)idx;
- (void)datumFree;

/////////////////////////////////////////////////////////////////////////
@end

// EOF
