// $Id: TTExecutor.h,v 5.3 1998/06/30 01:21:32 pb Exp $
/* Copyright (c) 1994-1998 TipTop Software, Inc.
   All Rights Reserved

   Author: Pedja Bogdanovich
*/

#ifndef _ObjCore_TTExecutor_h
#define _ObjCore_TTExecutor_h 1

#import <ObjCore/ObjCoreDefines.h>
#import <Foundation/Foundation.h>
#import <ObjCore/TTInterpValueProtocol.h>
#import <ObjCore/TTInterpProtocol.h>

@interface TTExecutor : TTObject <NSCoding>
{
  id <TTInterpProtocol> _interp;
  NSString *_languageName;
  NSString *_hostName;
  NSString *_connectionName;
  NSString *_interpName;
  NSString *_code;
  id <TTInterpValueProtocol> _sub;
  id _delegate;
  unsigned _eflags;
  void *_reserved;
}

- (id)interp;
- (void)setInterp:i;
- (id)getInterp;

- (NSString*)languageName;
- (void)setLanguageName:(NSString*)l;
- (NSString*)hostName;
- (void)setHostName:(NSString*)h;
- (NSString*)connectionName;
- (void)setConnectionName:(NSString*)n;
- (NSString*)interpName;
- (void)setInterpName:(NSString*)n;

- (void)setDelegate:(id)d;
- (id)delegate;

- (void)setSourceCode:(NSString *)c;
- (NSString *)sourceCode;
- (void)compileCodeIfNeeded;
- (id <TTInterpValueProtocol>)executeCodeWithArgs:(NSArray*)args;

- (id)initWithCoder:(NSCoder *)aDecoder;
- (void)encodeWithCoder:(NSCoder *)aCoder;

- (void)interpDidBecomeInvalid;

- (id)connectToRemoteInterp;
@end

#endif

// EOF
