// $Id: TTInteractor.h,v 5.3 1998/01/14 21:58:29 pb Exp $
/* Copyright (c) 1994-1998 TipTop Software, Inc.
   All Rights Reserved

   Author: Pedja Bogdanovich
*/

#ifndef _ObjCore_TTInteractor_h
#define _ObjCore_TTInteractor_h 1

#import <ObjCore/ObjCoreDefines.h>

#import <Foundation/NSObject.h>
#import <ObjCore/TTInteractorProtocol.h>
#import <ObjCore/TTExecutor.h>

@interface TTInteractor : TTExecutor <TTInteractorProtocol>
{
  id _pool;
  unsigned _iflags;
  unsigned char _running;
  int _modalCode;
  id /*<TTInterpValueProtocol>*/ _lastResult;
  void *_ireserved;
}

- (void)setDoAutorelease:(BOOL)f;
- (BOOL)doAutorelease;

- (void)setKeepAround:(BOOL)f;
- (BOOL)isKeptAround;

- (void)killCurrentCommand:sender;

- (void)printOut:(NSString *)text;
- (NSString*)readLineWithPrompt:(NSString*)prompt0
                            and:(NSString*)prompt2
                    defaultText:(NSString*)text;

@end

@interface TTInteractor(Convenience)
+ (TTInteractor*)interactorForInterp:(id)interp;
+ (TTInteractor*)runForInterp:(id)interp;
@end

#endif

// EOF
