// $Id: TTInterpProtocol.h,v 5.3 1998/06/30 01:21:36 pb Exp $
/* Copyright (c) 1994-1998 TipTop Software, Inc.
   All Rights Reserved

   Author: Pedja Bogdanovich
*/
#ifndef _ObjCore_TTInterpProtocol_h
#define _ObjCore_TTInterpProtocol_h 1
#import <ObjCore/ObjCoreDefines.h>
#import <objc/Protocol.h>
#import <ObjCore/TTInterpValueProtocol.h>
#import <ObjCore/TTInteractorProtocol.h>

@protocol TTInterpProtocol
// Info
// ====
- (NSString *)languageName;
- (NSString *)languageVersionName;

- (id)currentScope;

- (BOOL)isDead;

// Default interp
+ (id <TTInterpProtocol>)getDefaultInterp;

// Parsing help (used by interactors)
+ (BOOL)isExpressionComplete:(NSString*)cmd;
- (BOOL)isExpressionComplete:(NSString*)cmd;
- (NSString*)promptForInteractor:(id <TTInteractorProtocol>)i;

// Evaluation methods
// ==================
- (id <TTInterpValueProtocol>)
	evaluate:(NSString *)expr
	interactor:(id <TTInteractorProtocol>)i
	debugger:(id)debugger
	scope:(id)scope
	otherFlags:(unsigned)flags;

- (id <TTInterpValueProtocol>)
	evaluateFile:(NSString *)path
	interactor:(id <TTInteractorProtocol>)i
	debugger:(id)debugger
	scope:(id)scope
	otherFlags:(unsigned)flags;

// Conversion
// ==========
+ (Class)interpValueClass;
- (id)objectForValue:(id <TTInterpValueProtocol>)value flags:(unsigned)f;
- (id <TTInterpValueProtocol>)valueForObject:(id)obj flags:(unsigned)f;

// Library path
// ============
-(NSArray*)libPath;
-(void)addToLibPath:(NSString*)dir;
-(void)setLibPath:(NSArray*)dirarr;


// Variable access
// ===============
- (void)
	setVariableNamed:(NSString*)name
	inScope:(id)scope
	toValue:(id <TTInterpValueProtocol>)value
	otherFlags:(unsigned)flags;

- (id <TTInterpValueProtocol>)
	getValueForVariableNamed:(NSString*)name
	inScope:(id)scope
	otherFlags:(unsigned)flags;

@end
#endif // One time

// EOF
