// $Id: TTInterpValueProtocol.h,v 5.2 1998/06/26 14:36:01 pb Exp $
/* Copyright (c) 1994-1998 TipTop Software, Inc.
   All Rights Reserved

   Author: Pedja Bogdanovich
*/
#ifndef _ObjCore_TTInterpValueProtocol_h
#define _ObjCore_TTInterpValueProtocol_h 1
#import <ObjCore/ObjCoreDefines.h>

#import <Foundation/Foundation.h>

@protocol TTInterpValueProtocol
/////////////////////////////////////////////////////////////////////////////
// 1. Value as object
/////////////////////////////////////////////////////////////////////////////
- (id <TTInterpValueProtocol>)initForObject:(id)obj
                                      flags:(unsigned)flags;
- (id)objectValueWithFlags:(unsigned)flags;

/////////////////////////////////////////////////////////////////////////////
// 2. Value as string
/////////////////////////////////////////////////////////////////////////////
- (id <TTInterpValueProtocol>)initForString:(NSString*)string;
- (NSString*)representation;

/////////////////////////////////////////////////////////////////////////////
// 3. Value as low-level C datum
/////////////////////////////////////////////////////////////////////////////
- (id <TTInterpValueProtocol>)initForDatumType:(const char *)encoding
                                     atAddress:(const void *)address
                                         flags:(unsigned)flags;
- (void)storeAsDatumType:(const char *)encoding
               atAddress:(void *)address
                   flags:(unsigned)flags;
@end

#define TTCONVERT_STD  0x0000000
#define TTCONVERT_RAW  0x1000000
#define TTCONVERT_EXT  0x2000000
#define TTCONVERT_MASK 0x3000000
#endif
// EOF
