// $Id: TTReceptionist.h,v 5.3 1998/06/30 01:21:57 pb Exp $
/* Copyright (c) 1994-1998 TipTop Software, Inc.
   All Rights Reserved

   Author: Pedja Bogdanovich
*/
#ifndef _ObjCore_TTReceptionist_h
#define _ObjCore_TTReceptionist_h 1

#import <ObjCore/ObjCoreDefines.h>

#import <ObjCore/TTReceptionistProtocol.h>

// Server-side example:
//
// set r [TTReceptionist sharedInstance]
// $r setConnectionName: [@ "xyz"]
// $r setObject: $interp forKey: [@ "ObjTclInterp"]
// [NSRunLoop currentRunLoop] run
//
//
// Client-side example:
//
// set r [NSConnection \
//   rootProxyForConnectionWithRegisteredName: [@ "xyz"] host: [@ "*"]]
// $r setProtocolForProxy: [protocol TTReceptionistProtocol]
// set i2 [$r objectForKey: [@ "ObjTclInterp"] \
//               forClient: [TTRHostAuthenticator sharedRHostAuthenticator]]

@interface TTReceptionist:TTObject <TTReceptionistProtocol>
{
@private
  NSConnection *_connection;
  NSString *_connectionName;
  NSMutableDictionary *_objmap;
  NSMutableDictionary *_authmap;
  id _checker;
  id _delegate;
  id _defaultAuth;
}

//+ sharedInstance;
+ sharedReceptionist;
- (NSString*)setConnectionName:(NSString*)name;
- (NSDictionary*)dictionary;

- (void)setDefaultAuthenticator:(id)auth;
- (id)defaultAuthenticator;

- (NSString *)connectionName;
- (NSConnection *)connection;
- (id)sharedApplication;

- (id)objectForKey:(NSString *)name forClient:(id)client;
- (id)objectForKey:(NSString *)name;
- (void)setObject:(id)obj forKey:(NSString *)name authenticator:(id)auth;
- (void)setObject:(id)obj forKey:(NSString *)name;
@end

#endif
// EOF
