# $Id: ObjPerl.PPM,v 1.8 1997/04/08 19:08:54 pedja Exp $ -*-perl-*-
# Copyright (c) 1994-1998 TipTop Software, Inc.
# All Rights Reserved
#
#   Author: Pedja Bogdanovich

package ObjPerl;

require 5.004;
require Exporter;
require DynaLoader;
require AutoLoader;

$VERSION = '5.1' ;

use vars qw(
	$VERSION @ISA @EXPORT @EXPORT_OK
	$interp %CONFIG
	@CLASSPACKAGE
);

@ISA = qw(Exporter DynaLoader AutoLoader);

@EXPORT = qw(
	cdef cdefine cinclude unparse
	msg_send msg_send_super msg_send_ex
	class class_rename forget protocol
	lookup nil object_is_bad
	iget iset xset xget ivar_get ivar_set
	pl obj
	category_begin category_end method
	extend category
	super ex
	mbind
	dyload
	iprint ireadline mapobj
);

@EXPORT_OK = qw($interp %CONFIG);

bootstrap ObjPerl $VERSION;

@CLASSPACKAGE = qw(Class:: ObjPerl::Class:: ::);

sub LOADCLASS {
  #print "*** LOADCLASS: @_\n";
  my $class=shift;
  my $use;
  foreach (@CLASSPACKAGE) {
    $use="require $_$class;";
    #print "Trying to $use\n";
    eval $use;  # warn $@ if $@;
    return if C::objc_lookUpClass($class);
  };
  # Finally, try to load $class.objpl
  do "$class.objpl";
};

############################################################################
package ObjPerl::Object;

use overload
	'fallback' => TRUE,
	'""' => \&Id_2_String,
	'0+' => \&Id_2_Number,
	'bool' => \&Id_2_Boolean,
	'==' => \&Id_Is_Same,
	'!=' => \&Id_Is_Not_Same,
	'eq' => \&Id_Is_Equal,
	'ne' => \&Id_Is_Not_Equal,

# Incr/Decr kludge (Perl 5.001, 5.002):
	'++' => sub { $_[0]=&Id_2_Number($_[0])+1; },
#	'++' => sub { $_[0]=ObjPerl::obj(&Id_2_Number($_[0])+1); },
	'--' => sub { $_[0]=&Id_2_Number($_[0])-1; },
#	'--' => sub { $_[0]=ObjPerl::obj(&Id_2_Number($_[0])-1); },
	'=' => sub { return $_[0]; },
;

package Type;
use overload
	'""' => \&stringify;

package C;
use overload
	'""' => \&stringify;

#############################################################################
package ObjPerl::PSEUDO_STDINOUT;
sub TIEHANDLE {
  my ($class) = @_;
  my $xxx;
  bless \$xxx;
}

sub PRINT {
  my $self = shift;
  ObjPerl::iprint(@_);
}

sub PRINTF {
  my $self = shift;
  my $fmt = shift;
  $self->PRINT(sprintf($fmt,@_));
}

sub READLINE {
  my $self = shift;
  ObjPerl::pl(ObjPerl::ireadline(ObjPerl::obj('')));
}

tie(*ObjPerl::INOUT, 'ObjPerl::PSEUDO_STDINOUT');
select ObjPerl::INOUT;

#############################################################################
package ObjPerl;

$SIG{'__WARN__'} = sub {
  my $i=$ObjPerl::interp->_interactor;
  $i->_printErrorValue_(class('NSString')
	->stringWithCString_("WARNING: $_[0]"));
  warn $_[0];
};

sub iprint (@);
sub iprint (@) {                                              
  my $i=$ObjPerl::interp->_interactor;
  if(!nil($i)) {
    my $r=$i->printOut_(join("",@_));
    $i->window->displayIfNeeded if $i->respondsToSelector_('window');
    return $r;
  }
  return print STDOUT join("",@_);
}

sub ireadline ($);
sub ireadline ($) {
  my $i=$ObjPerl::interp->_interactor;
  return $i->readLineWithPrompt_and_defaultText_(shift,obj(''),obj(''))
    if !nil($i);
  my $line=<STDIN>;
  return $line;
}

sub mapobj (&$;$);
sub mapobj (&$;$) {
  my $body=shift;
  my $obj=shift;
  my $__enum=shift;
  $__enum=$obj->objectEnumerator if !$__enum;
  my @__r;
  while (!ObjPerl::nil($_=$__enum->nextObject)) {
    push @__r, &$body;
  }
  return @__r;
}

1;
__END__

# EOF
