// $Id: ObjPythonDefines.h,v 5.2 1998/07/02 05:24:50 pb Exp $
/* Copyright (c) 1994-1998 TipTop Software, Inc.
   All Rights Reserved
*/

#ifndef _ObjPythonCore_Defines_h
#define _ObjPythonCore_Defines_h 1

//////////
// MACH //
//////////
#if defined __MACH__

#ifdef __cplusplus
#  define OBJPYTHON_EXTERN		extern
#  define PRIVATE_EXTERN		__private_extern__
#else
#  define OBJPYTHON_EXTERN		extern
#  define PRIVATE_EXTERN		__private_extern__
#endif

#define OBJPYTHON_EXTERN_IMP	PUBLIC_EXTERN
#define PRIVATE_EXTERN_IMP	PRIVATE_EXTERN


/////////////
// Windows //
/////////////
#elif defined WIN32

#ifdef __cplusplus
#  ifndef BUILDING_OBJPYTHON
#    define OBJPYTHON_EXTERN		__declspec(dllexport) extern "C"
#  else
#    define OBJPYTHON_EXTERN		__declspec(dllimport) extern "C"
#  endif
#  define OBJPYTHON_PRIVATE_EXTERN		extern "C"
#else
#  ifndef BUILDING_OBJPYTHON
#    define OBJPYTHON_EXTERN		__declspec(dllexport) extern
#  else
#    define OBJPYTHON_EXTERN		__declspec(dllimport) extern
#  endif
#    define OBJPYTHON_PRIVATE_EXTERN		extern
#endif

#define OBJPYTHON_EXTERN_IMP	PUBLIC_EXTERN
#define OBJPYTHON_PRIVATE_EXTERN_IMP	PRIVATE_EXTERN


/////////////////////////////////
// Solaris and SolarisOpenStep //
/////////////////////////////////
#elif defined(__svr4__) || defined(sun)

#ifdef __cplusplus
#  define OBJPYTHON_EXTERN		extern "C"
#  define OBJPYTHON_PRIVATE_EXTERN		extern "C"
#else
#  define OBJPYTHON_EXTERN		extern
#  define OBJPYTHON_PRIVATE_EXTERN		extern
#endif

#define OBJPYTHON_EXTERN_IMP	OBJPYTHON_EXTERN
#define OBJPYTHON_PRIVATE_EXTERN_IMP	PRIVATE_EXTERN

///////////
// HP UX //
///////////
#elif defined(hpux)

#ifdef __cplusplus
#  define OBJPYTHON_EXTERN		extern "C"
#  define OBJPYTHON_PRIVATE_EXTERN		extern "C"
#else
#  define OBJPYTHON_EXTERN		extern
#  define OBJPYTHON_PRIVATE_EXTERN		extern
#endif

#define OBJPYTHON_EXTERN_IMP	OBJPYTHON_EXTERN
#define OBJPYTHON_PRIVATE_EXTERN_IMP	PRIVATE_EXTERN

/////////////////////
// SolarisOpenStep //
/////////////////////
#elif defined(SolarisOpenStep)

#ifdef __cplusplus
#  define OBJPYTHON_EXTERN		extern "C"
#  define OBJPYTHON_PRIVATE_EXTERN		extern "C"
#else
#  define OBJPYTHON_EXTERN		extern
#  define OBJPYTHON_PRIVATE_EXTERN		extern
#endif

#define OBJPYTHON_EXTERN_IMP	OBJPYTHON_EXTERN
#define OBJPYTHON_PRIVATE_EXTERN_IMP	PRIVATE_EXTERN

#else

#error Unknown platform.

#endif

#endif
// EOF
