// $Id: TTObjTclInterp.h,v 5.2 1998/06/26 14:36:24 pb Exp $
/* Copyright (c) 1994-1998 TipTop Software, Inc.
  All Rights Reserved

  Author: Pedja Bogdanovich
*/
#ifndef _ObjTclCore_TTObjTclInterp_h
#define _ObjTclCore_TTObjTclInterp_h 1

@interface TTObjTclInterp : TTInterp <TTInterpProtocol>
{
@private
  Tcl_Interp *_interp;
//  id <TTInteractorProtocol> _interactor;
  unsigned _flags;
  void *_reserved;
}

+ (void)setDefaultInterp:(TTObjTclInterp*)interp;
+ (TTObjTclInterp*)defaultInterp;
+ (TTObjTclInterp*)getDefaultInterp;

+ (TTObjTclInterp*)interpForTclInterp:(Tcl_Interp*)i;
- (Tcl_Interp *)tclInterp;
- (TTTclObject *)result;

// Initialization
- init;
- initWithTclInterp:(Tcl_Interp *)tclInterp;
- (int)objtclInit;
- (int)objtclAppInit;

// Master-slave methods
- (TTObjTclInterp*)slaveInterpWithPath:(NSString*)p;
- (TTObjTclInterp*)masterInterp;
- (NSString*)pathForSlaveInterp:(TTObjTclInterp*)slave;
- (TTObjTclInterp*)createSlave:(NSString*)p safe:(BOOL)safe;

// Global variable linking
- (void)linkVariableName:(NSString*)name
           typeEncoding:(const char*)type
                address:(void*)addr;
- (void)unlinkVariableName:(NSString*)name;

/////////////////////////////////////////////////////////////////////////////

@end

#endif
// EOF
