# $Id: objtcl.tcl,v 5.4 1998/06/21 18:41:27 pb Exp $
# Copyright (c) 1994-1998 TipTop Software, Inc.
# All Rights Reserved
#
# Author: Pedja Bogdanovich

#puts "*** running [::info script] ***"
package require Tcl 8.0
package require ObjTcl 5.1
lappend auto_path $objtcl_library

# Set up interactor stdin/stdout
rename ::puts ::default_puts; rename ::objtcl::iputs ::puts
rename ::gets ::default_gets; rename ::objtcl::igets ::gets

# Link globals
objtcl::defglob NSArgc
objtcl::defglob NSArgv
catch {objtcl::defglob NSApp}

#####################################################################
# Misc conveniences/shortcuts
#####################################################################

namespace eval ::appkit {
  namespace export interact dpsputs browse

  proc interact {} {
    global interp
    $interp newWInteractor: [nil]
  }

  proc dpsputs {pstext} {
    [NSDPSContext currentContext] printFormat: "$pstext\n"
  }

  proc browse {{object nil} {path ""}} {
    if ![TTInterp loadBrowser] {
      error "Could not load ObjBrowser"
    }
    TTObjBrowser browseFromObject: [$object] path: [@ $path]
  }
}

proc objtcl::log {text} {
  NSLog [@ %@] [@ $text]
}

#####################################################################
# By default, import all symbols from objtcl into the global namespace
if {[info commands "@"] != "@"} {
  namespace import objtcl::*
  namespace import appkit::*
}

#####################################################################
# Execute user-specific setup
if [file exists ~/.objtclrc] {
  if [catch {source ~/.objtclrc} err] {
    puts "~/.objtclrc: $err"
  }
}

# EOF
